//+------------------------------------------------------------------+
//|                                                     testIndi.mq5 |
//|                             Copyright 2010, Loong@forum.mql4.com |
//|                             http://login.mql5.com/en/users/Loong |
//+------------------------------------------------------------------+
#property copyright "2010, Loong@forum.mql4.com"
#property link      "http://login.mql5.com/en/users/Loong"
#property version   "1.00"

#include "testIndiBuffer.mqh"

#property indicator_separate_window
#property indicator_buffers iNumLines
#property indicator_plots   iNumLines

CLoongIndiSelect inds;
color iColor5Cycle[5] = {Red,Yellow,Lime,Blue,Magenta};
bool PlotIndexSetSolidLineColor(int plot_index, color iColor)
{
   PlotIndexSetInteger(plot_index,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(plot_index,PLOT_LINE_STYLE,STYLE_SOLID);
   PlotIndexSetInteger(plot_index,PLOT_COLOR_INDEXES,1); //Add by Loong 20100112
   PlotIndexSetInteger(plot_index,PLOT_LINE_COLOR,iColor);
   return(true);
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   color iColor = Red;
//--- indicator buffers mapping
   IndicatorSetString(INDICATOR_SHORTNAME,"LoongIndi");
   inds.Create(Symbol(), PERIOD_CURRENT, IND_MACD, 4, cIndiParamMACD);
   for(int i=0; i<iNumLines; i++)
   {
      //inds.SetIndexBuffer(i,INDICATOR_DATA);
      iColor = iColor5Cycle[i];
      PlotIndexSetSolidLineColor(i,iColor);
   }
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
//---
   int copied;
   copied=inds.GetData(rates_total);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
